(in-package :lambda-utils)

;;;
;;; Mime Types
;;;

(defparameter *mime-types*
  #{"3dm" 	"x-world/x-3dmf"
"3dmf" 	"x-world/x-3dmf"
"a" 	"application/octet-stream"
"aab" 	"application/x-authorware-bin"
"aam" 	"application/x-authorware-map"
"aas" 	"application/x-authorware-seg"
"abc" 	"text/vnd.abc"
"acgi" 	"text/html"
"afl" 	"video/animaflex"
"ai" 	"application/postscript"
"aif" 	"audio/aiff"
"aifc" 	"audio/aiff"
"aiff" 	"audio/aiff"
"aim"	"application/x-aim"
"aip"	"text/x-audiosoft-intra"
"ani"	"application/x-navi-animation"
"aos"	"application/x-nokia-9000-communicator-add-on-software"
"aps"	"application/mime"
"arj"	"application/arj"
"art"	"image/x-jg"
"asf"	"video/x-ms-asf"
"asm"	"text/x-asm"
"asp"	"text/asp"
"asx"	"video/x-ms-asf"
"au"	"audio/basic"
"avi"	"video/avi"
"avs"	"video/avs-video"
"bcpio"	"application/x-bcpio"
"bin"	"application/octet-stream"
"bm"	"image/bmp"
"bmp"	"image/bmp"
"boo"	"application/book"
"book"	"application/book"
"boz"	"application/x-bzip2"
"bsh"	"application/x-bsh"
"bz"	"application/x-bzip"
"bz2"	"application/x-bzip2"
"c"	"text/plain"
"c++"	"text/plain"
"cc"	"text/plain"
"ccad"	"application/clariscad"
"cco"	"application/x-cocoa"
"cdf"	"application/cdf"
"cer"	"application/x-x509-ca-cert"
"cha"	"application/x-chat"
"chat"	"application/x-chat"
"class"	"application/java-byte-code"
"csv"	"text/comma-separated-value"
"com"	"application/octet-stream"
"conf"	"text/plain"
"cpio"	"application/x-cpio"
"cpp"	"text/x-c"
"cpt"	"application/mac-compactpro"
"crl"	"application/pkcs-crl"
"crt"	"application/x-x509-user-cert"
"csh"	"application/x-csh"
"css"	"text/css"
"cxx"	"text/plain"
"dat"   "text/plain"
"dcr"	"application/x-director"
"deepv"	"application/x-deepv"
"def"	"text/plain"
"der"	"application/x-x509-ca-cert"
"dif"	"video/x-dv"
"dir"	"application/x-director"
"dl"	"video/dl"
"dl"	"video/x-dl"
"doc"	"application/msword"
"dot"	"application/msword"
"dp"	"application/commonground"
"drw"	"application/drafting"
"dump"	"application/octet-stream"
"dv"	"video/x-dv"
"dvi"	"application/x-dvi"
"dwf"	"model/vnd.dwf"
"dwg"	"application/acad"
"dxf"	"application/dxf"
"dxr"	"application/x-director"
"el"	"text/x-script.elisp"
"elc"	"application/x-bytecode.elisp"
"elc"	"application/x-elc"
"env"	"application/x-envoy"
"eps"	"application/postscript"
"es"	"application/x-esrehber"
"etx"	"text/x-setext"
"evy"	"application/envoy"
"exe"	"application/octet-stream"
"f"	"text/plain"
"f77"	"text/x-fortran"
"f90"	"text/x-fortran"
"fdf"	"application/vnd.fdf"
"fif"	"application/fractals"
"fif"	"image/fif"
"fli"	"video/fli"
"fli"	"video/x-fli"
"flo"	"image/florian"
"flx"	"text/vnd.fmi.flexstor"
"fmf"	"video/x-atomic3d-feature"
"for"	"text/plain"
"for"	"text/x-fortran"
"fpx"	"image/vnd.fpx"
"frl"	"application/freeloader"
"funk"	"audio/make"
"g"	"text/plain"
"g3"	"image/g3fax"
"gif"	"image/gif"
"gl"	"video/gl"
"gl"	"video/x-gl"
"gsd"	"audio/x-gsm"
"gsm"	"audio/x-gsm"
"gsp"	"application/x-gsp"
"gss"	"application/x-gss"
"gtar"	"application/x-gtar"
"gz"	"application/x-gzip"
"gzip"	"application/x-gzip"
"h"	"text/plain"
"hdf"	"application/x-hdf"
"help"	"application/x-helpfile"
"hgl"	"application/vnd.hp-hpgl"
"hh"	"text/plain"
"hh"	"text/x-h"
"hlb"	"text/x-script"
"hlp"	"application/x-helpfile"
"hpg"	"application/vnd.hp-hpgl"
"hpgl"	"application/vnd.hp-hpgl"
"hqx"	"application/binhex"
"hta"	"application/hta"
"htc"	"text/x-component"
"htm"	"text/html"
"html"	"text/html"
"htmls"	"text/html"
"htt"	"text/webviewhtml"
"htx"	"text/html"
"ice"	"x-conference/x-cooltalk"
"ico"	"image/x-icon"
"idc"	"text/plain"
"ief"	"image/ief"
"iefs"	"image/ief"
"iges"	"application/iges"
"igs"	"application/iges"
"ima"	"application/x-ima"
"imap"	"application/x-httpd-imap"
"inf"	"application/inf"
"ins"	"application/x-internett-signup"
"ip"	"application/x-ip2"
"isu"	"video/x-isvideo"
"it"	"audio/it"
"iv"	"application/x-inventor"
"ivr"	"i-world/i-vrml"
"ivy"	"application/x-livescreen"
"jam"	"audio/x-jam"
"jav"	"text/plain"
"java"	"text/plain"
"jcm"	"application/x-java-commerce"
"jfif"	"image/jpeg"
"jfif-tb" "image/jpeg"
"jpe"	"image/jpeg"
"jpeg"	"image/jpeg"
"jpg"	"image/jpeg"
"jps"	"image/x-jps"
"js"	"application/x-javascript"
"jut"	"image/jutvision"
"kar"	"audio/midi"
"ksh"	"application/x-ksh"
"la"	"audio/nspaudio"
"lam"	"audio/x-liveaudio"
"latex"	"application/x-latex"
"lisp"  "application/x-lisp"
"lha"	"application/lha"
"lhx"	"application/octet-stream"
"list"	"text/plain"
"lma"	"audio/nspaudio"
"log"	"text/plain"
"lsp"	"application/x-lisp"
"lst"	"text/plain"
"lsx"	"text/x-la-asf"
"ltx"	"application/x-latex"
"lzh"	"application/x-lzh"
"lzx"	"application/lzx"
"lzx"	"application/x-lzx"
"m"	"text/plain"
"m1v"	"video/mpeg"
"m2a"	"audio/mpeg"
"m2v"	"video/mpeg"
"m3u"	"audio/x-mpequrl"
"man"	"application/x-troff-man"
"map"	"application/x-navimap"
"mar"	"text/plain"
"mbd"	"application/mbedlet"
"mc$"	"application/x-magic-cap-package-1.0"
"mcd"	"application/mcad"
"mcd"	"application/x-mathcad"
"mcf"	"text/mcf"
"mcp"	"application/netmc"
"me"	"application/x-troff-me"
"mht"	"message/rfc822"
"mhtml"	"message/rfc822"
"mid"	"application/x-midi"
"mid"	"audio/midi"
"midi"	"audio/midi"
"mif"	"application/x-frame"
"mime"	"www/mime"
"mjf"	"audio/x-vnd.audioexplosion.mjuicemediafile"
"mjpg"	"video/x-motion-jpeg"
"mm"	"application/base64"
"mme"	"application/base64"
"mod"	"audio/mod"
"moov"	"video/quicktime"
"mov"	"video/quicktime"
"movie"	"video/x-sgi-movie"
"mp2"	"audio/mpeg"
"mp3"	"video/mpeg"
"mpa"	"audio/mpeg"
"mpc"	"application/x-project"
"mpe"	"video/mpeg"
"mpeg"	"video/mpeg"
"mpg"	"video/mpeg"
"mpga"	"audio/mpeg"
"mpp"	"application/vnd.ms-project"
"mpt"	"application/x-project"
"mpv"	"application/x-project"
"mpx"	"application/x-project"
"mrc"	"application/marc"
"ms"	"application/x-troff-ms"
"mv"	"video/x-sgi-movie"
"my"	"audio/make"
"mzz"	"application/x-vnd.audioexplosion.mzz"
"nap"	"image/naplps"
"naplps""	image/naplps"
"nc"	"application/x-netcdf"
"ncm"	"application/vnd.nokia.configuration-message"
"nif"	"image/x-niff"
"niff"	"image/x-niff"
"nix"	"application/x-mix-transfer"
"nsc"	"application/x-conference"
"nvd"	"application/x-navidoc"
"o"	"application/octet-stream"
"oda"	"application/oda"
"omc"	"application/x-omc"
"omcd"	"application/x-omcdatamaker"
"omcr"	"application/x-omcregerator"
"p"	"text/x-pascal"
"p10"	"application/pkcs10"
"p12"	"application/pkcs-12"
"p7a"	"application/x-pkcs7-signature"
"p7c"	"application/pkcs7-mime"
"p7m"	"application/pkcs7-mime"
"p7r"	"application/x-pkcs7-certreqresp"
"p7s"	"application/pkcs7-signature"
"part"	"application/pro_eng"
"pas"	"text/pascal"
"pbm"	"image/x-portable-bitmap"
"pcl"	"application/x-pcl"
"pct"	"image/x-pict"
"pcx"	"image/x-pcx"
"pdb"	"chemical/x-pdb"
"pdf"	"application/pdf"
"pfunk"	"audio/make"
"pfunk"	"audio/make.my.funk"
"pgm"	"image/x-portable-graymap"
"pic"	"image/pict"
"pict"	"image/pict"
"pkg"	"application/x-newton-compatible-pkg"
"pko"	"application/vnd.ms-pki.pko"
"pl"	"text/plain"
"pl"	"text/x-script.perl"
"plx"	"application/x-pixclscript"
"pm"	"image/x-xpixmap"
"pm"	"text/x-script.perl-module"
"pm4"	"application/x-pagemaker"
"pm5"	"application/x-pagemaker"
"png"	"image/png"
"pnm"	"image/x-portable-anymap"
"pot"	"application/mspowerpoint"
"pov"	"model/x-pov"
"ppa"	"application/vnd.ms-powerpoint"
"ppm"	"image/x-portable-pixmap"
"pps"	"application/mspowerpoint"
"pps"	"application/vnd.ms-powerpoint"
"ppt"	"application/mspowerpoint"
"ppz"	"application/mspowerpoint"
"pre"	"application/x-freelance"
"prt"	"application/pro_eng"
"ps"	"application/postscript"
"psd"	"application/octet-stream"
"pvu"	"paleovu/x-pv"
"pwz"	"application/vnd.ms-powerpoint"
"py"	"text/x-script.phyton"
"pyc"	"applicaiton/x-bytecode.python"
"qcp"	"audio/vnd.qcelp"
"qd3"	"x-world/x-3dmf"
"qd3d"	"x-world/x-3dmf"
"qif"	"image/x-quicktime"
"qt"	"video/quicktime"
"qtc"	"video/x-qtc"
"qti"	"image/x-quicktime"
"qtif"	"image/x-quicktime"
"ra"	"audio/x-realaudio"
"ram"	"audio/x-pn-realaudio"
"ras"	"image/cmu-raster"
"rast"	"image/cmu-raster"
"rexx"	"text/x-script.rexx"
"rf"	"image/vnd.rn-realflash"
"rgb"	"image/x-rgb"
"rm"	"audio/x-pn-realaudio"
"rmi"	"audio/mid"
"rmm"	"audio/x-pn-realaudio"
"rmp"	"audio/x-pn-realaudio"
"rng"	"application/ringing-tones"
"rnx"	"application/vnd.rn-realplayer"
"roff"	"application/x-troff"
"rp"	"image/vnd.rn-realpix"
"rpm"	"audio/x-pn-realaudio-plugin"
"rt"	"text/richtext"
"rtf"	"text/richtext"
"rtx"	"text/richtext"
"rv"	"video/vnd.rn-realvideo"
"s"	"text/x-asm"
"s3m"	"audio/s3m"
"saveme" "application/octet-stream"
"sbk"	"application/x-tbook"
"scm"	"text/x-script.scheme"
"scm"	"video/x-scm"
"sdml"	"text/plain"
"sdp"	"application/sdp"
"sdr"	"application/sounder"
"sea"	"application/sea"
"set"	"application/set"
"sgm"	"text/sgml"
"sgml"	"text/sgml"
"sh"	"application/x-sh"
"shar"	"application/x-shar"
"shtml"	"text/html"
"sid"	"audio/x-psid"
"sit"	"application/x-stuffit"
"skd"	"application/x-koan"
"skm"	"application/x-koan"
"skp"	"application/x-koan"
"skt"	"application/x-koan"
"sl"	"application/x-seelogo"
"smi"	"application/smil"
"smil"	"application/smil"
"snd"	"audio/basic"
"snd"	"audio/x-adpcm"
"sol"	"application/solids"
"spc"	"application/x-pkcs7-certificates"
"spl"	"application/futuresplash"
"spr"	"application/x-sprite"
"sprite" "application/x-sprite"
"src"	"application/x-wais-source"
"ssi"	"text/x-server-parsed-html"
"ssm"	"application/streamingmedia"
"sst"	"application/vnd.ms-pki.certstore"
"step"	"application/step"
"stl"	"application/x-navistyle"
"stp"	"application/step"
"sv4cpio""	application/x-sv4cpio"
"sv4crc""	application/x-sv4crc"
"svf"	"image/x-dwg"
"svr"	"application/x-world"
"swf"	"application/x-shockwave-flash"
"t"	"application/x-troff"
"talk"	"text/x-speech"
"tar"	"application/x-tar"
"tbk"	"application/toolbook"
"tbk"	"application/x-tbook"
"tcl"	"application/x-tcl"
"tcsh"	"text/x-script.tcsh"
"tex"	"application/x-tex"
"texi"	"application/x-texinfo"
"texinfo" "application/x-texinfo"
"text"	"text/plain"
"tgz"	"application/gnutar"
"tif"	"image/tiff"
"tiff"	"image/tiff"
"tr"	"application/x-troff"
"tsi"	"audio/tsp-audio"
"tsp"	"audio/tsplayer"
"tsv"	"text/tab-separated-values"
"turbot" "image/florian"
"txt"	"text/plain"
"uil"	"text/x-uil"
"uni"	"text/uri-list"
"unis"	"text/uri-list"
"unv"	"application/i-deas"
"uri"	"text/uri-list"
"uris"	"text/uri-list"
"ustar"	"application/x-ustar"
"uu"	"text/x-uuencode"
"uue"	"text/x-uuencode"
"vcd"	"application/x-cdlink"
"vcs"	"text/x-vcalendar"
"vda"	"application/vda"
"vdo"	"video/vdo"
"vew"	"application/groupwise"
"viv"	"video/vivo"
"vivo"	"video/vivo"
"vmd"	"application/vocaltec-media-desc"
"vmf"	"application/vocaltec-media-file"
"voc"	"audio/voc"
"vos"	"video/vosaic"
"vox"	"audio/voxware"
"vqe"	"audio/x-twinvq-plugin"
"vqf"	"audio/x-twinvq"
"vql"	"audio/x-twinvq-plugin"
"vrml"	"model/vrml"
"vrt"	"x-world/x-vrt"
"vsd"	"application/x-visio"
"vst"	"application/x-visio"
"vsw"	"application/x-visio"
"w60"	"application/wordperfect6.0"
"w61"	"application/wordperfect6.1"
"w6w"	"application/msword"
"wav"	"audio/wav"
"wb1"	"application/x-qpro"
"wbmp"	"image/vnd.wap.wbmp"
"web"	"application/vnd.xara"
"wiz"	"application/msword"
"wk1"	"application/x-123"
"wmf"	"windows/metafile"
"wml"	"text/vnd.wap.wml"
"wmlc"	"application/vnd.wap.wmlc"
"wmls"	"text/vnd.wap.wmlscript"
"wmlsc"	"application/vnd.wap.wmlscriptc"
"word"	"application/msword"
"wp"	"application/wordperfect"
"wp5"	"application/wordperfect"
"wp5"	"application/wordperfect6.0"
"wp6"	"application/wordperfect"
"wpd"	"application/wordperfect"
"wq1"	"application/x-lotus"
"wri"	"application/mswrite"
"wrl"	"model/vrml"
"wrz"	"model/vrml"
"wsc"	"text/scriplet"
"wsrc"	"application/x-wais-source"
"wtk"	"application/x-wintalk"
"xbm"	"image/x-xbitmap"
"xdr"	"video/x-amt-demorun"
"xgz"	"xgl/drawing"
"xif"	"image/vnd.xiff"
"xl"	"application/excel"
"xla"	"application/excel"
"xlb"	"application/excel"
"xlc"	"application/excel"
"xld"	"application/excel"
"xlk"	"application/excel"
"xll"	"application/excel"
"xlm"	"application/excel"
"xls"	"application/excel"
"xlt"	"application/excel"
"xlv"	"application/excel"
"xlw"	"application/excel"
"xm"	"audio/xm"
"xml"	"text/xml"
"xmz"	"xgl/movie"
"xpix"	"application/x-vnd.ls-xpix"
"xpm"	"image/xpm"
"x-png"	"image/png"
"xsr"	"video/x-amt-showrun"
"xwd"	"image/x-xwd"
"xyz"	"chemical/x-pdb"
"z"	"application/x-compressed"
"zip"	"application/zip"
"zoo"	"application/octet-stream"
"zsh"	"text/x-script.zsh"})


(defun mime-type (filename)
  (or (gethash (pathname-type (pathname filename)) *mime-types*)
      "application/octet-stream"))

;;
;; typed open
;;

(defparameter *mime-handlers* #{
"application/octet-stream"		:binary
"application/x-sprite"			:binary
"application/x-sv4crc"			:binary
"image/florian"				:binary
"image/naplps"				:binary
"application/x-sv4cpio"			:binary
"application/x-texinfo"			:binary
"applicaiton/x-bytecode.python"		:binary
"application/acad"			:binary
"application/arj"			:binary
"application/base64"			:binary
"application/binhex"			:binary
"application/book"			:binary
"application/cdf"			:binary
"application/clariscad"			:binary
"application/commonground"		:binary
"application/drafting"			:binary
"application/dxf"			:binary
"application/envoy"			:binary
"application/excel"			:binary
"application/fractals"			:binary
"application/freeloader"		:binary
"application/futuresplash"		:binary
"application/gnutar"			:binary
"application/groupwise"			:binary
"application/hta"			:binary
"application/i-deas"			:binary
"application/iges"			:binary
"application/inf"			:binary
"application/java-byte-code"		:binary
"application/lha"			:binary
"application/lzx"			:binary
"application/mac-compactpro"		:binary
"application/marc"			:binary
"application/mbedlet"			:binary
"application/mcad"			:binary
"application/mime"			:binary
"application/mspowerpoint"		:binary
"application/msword"			:binary
"application/mswrite"			:binary
"application/netmc"			:binary
"application/octet-stream"		:binary
"application/oda"			:binary
"application/pdf"			:binary
"application/pkcs-12"			:binary
"application/pkcs-crl"			:binary
"application/pkcs10"			:binary
"application/pkcs7-mime"		:binary
"application/pkcs7-signature"		:binary
"application/pkix-cert"			:binary
"application/postscript"		:binary
"application/pro_eng"			:binary
"application/ringing-tones"		:binary
"application/sdp"			:binary
"application/sea"			:binary
"application/set"			:binary
"application/smil"			:binary
"application/solids"			:binary
"application/sounder"			:binary
"application/step"			:binary
"application/streamingmedia"		:binary
"application/toolbook"			:binary
"application/vda"			:binary
"application/vnd.fdf"			:binary
"application/vnd.hp-hpgl"		:binary
"application/vnd.ms-pki.certstore"	:binary
"application/vnd.ms-pki.pko"		:binary
"application/vnd.ms-powerpoint"		:binary
"application/vnd.ms-project"		:binary
"application/vnd.nokia.configuration-message" :binary
"application/vnd.rn-realplayer"		:binary
"application/vnd.wap.wmlc"		:binary
"application/vnd.wap.wmlscriptc"	:binary
"application/vnd.xara"			:binary
"application/vocaltec-media-desc"	:binary
"application/vocaltec-media-file"	:binary
"application/wordperfect"		:binary
"application/wordperfect6.0"		:binary
"application/wordperfect6.1"		:binary
"application/x-123"			:binary
"application/x-aim"			:binary
"application/x-authorware-bin"		:binary
"application/x-authorware-map"		:binary
"application/x-authorware-seg"		:binary
"application/x-bcpio"			:binary
"application/x-bsh"			:binary
"application/x-bytecode.elisp"          :binary
"application/x-bzip"			:binary
"application/x-bzip2"			:binary
"application/x-cdlink"			:binary
"application/x-chat"			:binary
"application/x-cocoa"			:binary
"application/x-compressed"		:binary
"application/x-conference"		:binary
"application/x-cpio"			:binary
"application/x-csh"			:binary
"application/x-deepv"			:binary
"application/x-director"		:binary
"application/x-dvi"			:binary
"application/x-elc"			:binary
"application/x-envoy"			:binary
"application/x-esrehber"		:binary
"application/x-frame"			:binary
"application/x-freelance"		:binary
"application/x-gsp"			:binary
"application/x-gss"			:binary
"application/x-gtar"			:binary
"application/x-hdf"			:binary
"application/x-helpfile"		:binary
"application/x-httpd-imap"		:binary
"application/x-ima"			:binary
"application/x-internett-signup"	:binary
"application/x-inventor"		:binary
"application/x-ip2"			:binary
"application/x-java-commerce"		:binary
"application/x-javascript"		:binary
"application/x-koan"			:binary
"application/x-livescreen"		:binary
"application/x-lotus"			:binary
"application/x-lzh"			:binary
"application/x-lzx"			:binary
"application/x-magic-cap-package-1.0"	:binary
"application/x-mathcad"			:binary
"application/x-midi"			:binary
"application/x-mix-transfer"		:binary
"application/x-navi-animation"		:binary
"application/x-navidoc"			:binary
"application/x-navimap"			:binary
"application/x-navistyle"		:binary
"application/x-netcdf"			:binary
"application/x-newton-compatible-pkg"	:binary
"application/x-nokia-9000-communicator-add-on-software" :binary
"application/x-omc"			:binary
"application/x-omcdatamaker"		:binary
"application/x-omcregerator"		:binary
"application/x-pagemaker"		:binary
"application/x-pcl"			:binary
"application/x-pixclscript"		:binary
"application/x-pkcs7-certificates"	:binary
"application/x-pkcs7-certreqresp"	:binary
"application/x-pkcs7-signature"		:binary
"application/x-project"			:binary
"application/x-qpro"			:binary
"application/x-seelogo"			:binary
"application/x-shockwave-flash"		:binary
"application/x-sprite"			:binary
"application/x-stuffit"			:binary
"application/x-tar"			:binary
"application/x-tbook"			:binary
"application/x-tcl"			:binary
"application/x-texinfo"			:binary
"application/x-troff"			:binary
"application/x-troff-man"		:binary
"application/x-troff-me"		:binary
"application/x-troff-ms"		:binary
"application/x-ustar"			:binary
"application/x-visio"			:binary
"application/x-vnd.audioexplosion.mzz"	:binary
"application/x-vnd.ls-xpix"		:binary
"application/x-wais-source"		:binary
"application/x-wintalk"			:binary
"application/x-world"			:binary
"application/x-x509-ca-cert"		:binary
"application/x-x509-user-cert"		:binary
"audio/aiff"				:binary
"audio/basic"				:binary
"audio/it"				:binary
"audio/make"				:binary
"audio/make.my.funk"			:binary
"audio/mid"				:binary
"audio/midi"				:binary
"audio/mod"				:binary
"audio/mpeg"				:binary
"audio/nspaudio"			:binary
"audio/s3m"				:binary
"audio/tsp-audio"			:binary
"audio/tsplayer"			:binary
"audio/vnd.qcelp"			:binary
"audio/voc"				:binary
"audio/voxware"				:binary
"audio/wav"				:binary
"audio/x-adpcm"				:binary
"audio/x-gsm"				:binary
"audio/x-jam"				:binary
"audio/x-liveaudio"			:binary
"audio/x-mpequrl"			:binary
"audio/x-pn-realaudio"			:binary
"audio/x-pn-realaudio-plugin"		:binary
"audio/x-psid"				:binary
"audio/x-realaudio"			:binary
"audio/x-twinvq"			:binary
"audio/x-twinvq-plugin"			:binary
"audio/x-vnd.audioexplosion.mjuicemediafile" :binary
"audio/xm"				:binary
"chemical/x-pdb"			:binary
"i-world/i-vrml"			:binary
"image/bmp"				:binary
"image/cmu-raster"			:binary
"image/fif"				:binary
"image/florian"				:binary
"image/g3fax"				:binary
"image/gif"				:binary
"image/ief"				:binary
"image/jpeg"				:binary
"image/jutvision"			:binary
"image/naplps"				:binary
"image/pict"				:binary
"image/png"				:binary
"image/tiff"				:binary
"image/vnd.fpx"				:binary
"image/vnd.rn-realflash"		:binary
"image/vnd.rn-realpix"			:binary
"image/vnd.wap.wbmp"			:binary
"image/vnd.xiff"			:binary
"image/x-dwg"				:binary
"image/x-icon"				:binary
"image/x-jg"				:binary
"image/x-jps"				:binary
"image/x-niff"				:binary
"image/x-pcx"				:binary
"image/x-pict"				:binary
"image/x-portable-anymap"		:binary
"image/x-portable-bitmap"		:binary
"image/x-portable-graymap"		:binary
"image/x-portable-pixmap"		:binary
"image/x-quicktime"			:binary
"image/x-rgb"				:binary
"image/x-xbitmap"			:binary
"image/x-xpixmap"			:binary
"image/x-xwd"				:binary
"image/xpm"				:binary
"message/rfc822"			:binary
"model/vnd.dwf"				:binary
"model/vrml"				:binary
"model/x-pov"				:binary
"paleovu/x-pv"				:binary
"video/animaflex"			:binary
"video/avi"				:binary
"video/avs-video"			:binary
"video/dl"				:binary
"video/fli"				:binary
"video/gl"				:binary
"video/mpeg"				:binary
"video/quicktime"			:binary
"video/vdo"				:binary
"video/vivo"				:binary
"video/vnd.rn-realvideo"		:binary
"video/vosaic"				:binary
"video/x-amt-demorun"			:binary
"video/x-amt-showrun"			:binary
"video/x-atomic3d-feature"		:binary
"video/x-dl"				:binary
"video/x-dv"				:binary
"video/x-fli"				:binary
"video/x-gl"				:binary
"video/x-isvideo"			:binary
"video/x-motion-jpeg"			:binary
"video/x-ms-asf"			:binary
"video/x-qtc"				:binary
"video/x-scm"				:binary
"video/x-sgi-movie"			:binary
"windows/metafile"			:binary
"www/mime"				:binary
"x-conference/x-cooltalk"		:binary
"x-world/x-3dmf"			:binary
"x-world/x-vrt"				:binary
"xgl/drawing"				:binary
"xgl/movie"				:binary
"text/comma-separated-value"		:text
"application/x-ksh"			:text
"application/x-tex"			:text
"application/x-latex"			:text
"application/x-lisp"			:text
"application/x-sh"			:text
"application/x-shar"			:text
"text/asp"				:text
"text/css"				:text
"text/html"				:text
"text/mcf"				:text
"text/pascal"				:text
"text/plain"				:text
"text/richtext"				:text
"text/scriplet"				:text
"text/sgml"				:text
"text/tab-separated-values"		:text
"text/uri-list"				:text
"text/vnd.abc"				:text
"text/vnd.fmi.flexstor"			:text
"text/vnd.wap.wml"			:text
"text/vnd.wap.wmlscript"		:text
"text/webviewhtml"			:text
"text/x-asm"				:text
"text/x-audiosoft-intra"		:text
"text/x-c"				:text
"text/x-component"			:text
"text/x-fortran"			:text
"text/x-h"				:text
"text/x-la-asf"				:text
"text/x-pascal"				:text
"text/x-script"				:text
"text/x-script.elisp"			:text
"text/x-script.perl"			:text
"text/x-script.perl-module"		:text
"text/x-script.phyton"			:text
"text/x-script.rexx"			:text
"text/x-script.scheme"			:text
"text/x-script.tcsh"			:text
"text/x-script.zsh"			:text
"text/x-server-parsed-html"		:text
"text/x-setext"				:text
"text/x-speech"				:text
"text/x-uil"				:text
"text/x-uuencode"			:text
"text/x-vcalendar"			:text
"text/xml"				:xml
"application/zip"			:binary
"application/x-gzip"			:gzip})

(defgeneric typed-open* (filename file-type direction args)
  (:documentation "Open file according file-type"))

(defmethod typed-open* (filename (file-type (eql :text)) direction args)
  (apply #'open (nconc `(,filename :direction ,direction) args)))

;; TODO: add apropriate typed-open method for xml type
(defmethod typed-open* (filename (file-type (eql :xml)) direction args)
  (apply #'open (nconc `(,filename) args)))

(defmethod typed-open* (filename (file-type (eql :binary)) direction args)
  (apply #'open (nconc `(,filename :element-type (unsigned-byte 8)) args)))

(defmethod typed-open* (filename (file-type (eql :gzip)) (direction (eql :input)) args)
  (let ((gzip-stream
	 (make-gzip-input-stream
	  (apply #'open (nconc
			 `(,filename :element-type (unsigned-byte 8))
			 args)))))
    (make-flexi-stream gzip-stream :external-format *default-external-format*)))

(defun mime-handler (mime)
  (or (gethash mime *mime-handlers*)
      :binary))

(defun typed-open (filename  &rest args &key mime (direction :input) &allow-other-keys)
  "Open file according file-type and return (values stream mime-type)"
  (unless mime
    (setf mime (mime-type filename)))
  (remf args :mime)
  (values (typed-open* filename (mime-handler mime) direction args)
	  mime))


  
  ;; Util Functions
(defmacro with-open-typed-file ((var path &rest options)
                               &body body)
  (let ((abortp (gensym "abort")))
    `(let ((,var (typed-open ,path ,@options))
           (,abortp t))
       (unwind-protect 
           (multiple-value-prog1 (progn ,@body)
             (setf ,abortp nil))
         (close ,var :abort ,abortp)))))
